<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SocialSubGroup StructType
 * @subpackage Structs
 */
class SocialSubGroup extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The SocialGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SocialSubGroup
     */
    public $SocialGroup;
    /**
     * Constructor method for SocialSubGroup
     * @uses SocialSubGroup::setName()
     * @uses SocialSubGroup::setSocialGroup()
     * @param string $name
     * @param \StructType\SocialSubGroup $socialGroup
     */
    public function __construct($name = null, \StructType\SocialSubGroup $socialGroup = null)
    {
        $this
            ->setName($name)
            ->setSocialGroup($socialGroup);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\SocialSubGroup
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get SocialGroup value
     * @return \StructType\SocialSubGroup|null
     */
    public function getSocialGroup()
    {
        return $this->SocialGroup;
    }
    /**
     * Set SocialGroup value
     * @param \StructType\SocialSubGroup $socialGroup
     * @return \StructType\SocialSubGroup
     */
    public function setSocialGroup(\StructType\SocialSubGroup $socialGroup = null)
    {
        $this->SocialGroup = $socialGroup;
        return $this;
    }
}
